<?php

class GameManager {
    
    public function updateStats($UID, $STAT) {
        
        if(isset($UID) && isset($STAT)) { 
            
                $select = DatabaseManager::selectBySQL("SELECT * FROM stats WHERE id={$UID}"); 
                foreach($select as $arr) {
                    $stats = $arr;
                }
                $gold_needed = $stats[$STAT] * 2; //potrzebne złoto do podniesienia statystyki
                
                if($gold_needed > $stats['gold']) { //niewystarczająca ilość złota
                    return false;
                    exit;
                }
                
                else {
                    $stats_inc = $stats[$STAT] + 1;
                    $gold_aft = $stats['gold'] - ($stats[$STAT] * 2);
                    $res = DatabaseManager::updateTable("stats", Array(''.$STAT.'' => ''.$stats_inc.'',
                                                                        'gold' => ''.$gold_aft.''),
                                                              Array('id' => ''.$UID.'')); //aktualizacja bazy danych
                    if($res) { 
                        return true;
                    } else {
                        return false; //niepowodzenie, zwracamy false
                    }
                }                                                               
      
        } else {      
            return false; // zwracamy false           
        }       
    }  
    
   public function sendToWork($UID, $TIME) {
        
        if(isset($UID) && isset($TIME)) { 
            
                $select = DatabaseManager::selectBySQL("SELECT * FROM work WHERE uid={$UID}"); 
                
                
                
                if($select) { //znaleziono już pracę
                    return false;
                    exit;
                }
                
                else {
                    
                    $seconds = time() + ($TIME * 3600);
                    $reward = ($seconds / 1000000) * $TIME;
                    
                    $res = DatabaseManager::insertInto("work", Array('uid' => ''.$UID.'',
                                                                      'finish_date' => ''.$seconds.'', 
                                                                      'reward' => ''.$reward.''));
                    if($res) { 
                        return true;
                    } else {
                        return false; //niepowodzenie, zwracamy false
                    }
                }                                                               
      
        } else {      
            return false; // zwracamy false           
        }       
    } 
    
    public function checkWorkStatus($UID) {
        
     
                $akt = time();
                $select = DatabaseManager::selectBySQL("SELECT * FROM work WHERE uid={$UID} AND finish_date<{$akt}"); 
                
                
                
                if($select) { 
                    $select2 = DatabaseManager::selectBySQL("SELECT * FROM stats WHERE id={$UID}"); 
                    
                    foreach($select2 as $arr) {
                        $stats = $arr;
                    }
                    
                    foreach($select as $arr){
                        $reward = $arr;
                    }    
                    $update_gold = $stats['gold'] + $reward['reward'];
                    DatabaseManager::updateTable("stats", Array('gold' => ''.$update_gold.''), Array('id' => ''.$UID.''));
                    DatabaseManager::deleteFrom("work", array('uid' => ''.$UID.''));
                }
                
                else {
                    return false;
                    exit;
                }                                                                       
    }
    
    public function buyItem($UID, $NAME, $PRICE, $DEFENSE, $ATTACK) {
        
     
                $select = DatabaseManager::selectBySQL("SELECT * FROM stats WHERE id={$UID} AND gold>{$PRICE}"); //sprawdzenie czy użytkownik ma wystarczająco złota
                
                
                
                if($select) { //ma wystarczająco
                       
                    foreach($select as $arr) {
                        $stats = $arr;
                    }
                        
                    $update_gold = $stats['gold'] - $PRICE; //obliczenie złota po kupieniu przedmiotu
                     
                    DatabaseManager::updateTable("stats", Array('gold' => ''.$update_gold.''), Array('id' => ''.$UID.'')); //odjęcie złota z konta gracza
                        
                    $res = DatabaseManager::insertInto("items", Array('uid' => ''.$UID.'',
                                                                        'name' => ''.$NAME.'',
                                                                        'defense' => ''.$DEFENSE.'',
                                                                        'attack' => ''.$ATTACK.'',
                                                                        'is_equipped' => '0'      
                                                                        )); //dodanie przedmiotu do tabeli items
                    if($res) {
                        return true;                                                  
                    }
                        
                    else {
                        return false;
                    }
                  
                } //brakuje złota
                
                else {
                    return false;
                    exit;
                }                                                                       
    }   
    
    public function equipItem($UID, $ITEM_ID, $NAME) {
        
     
                $select = DatabaseManager::selectBySQL("SELECT * FROM items WHERE is_equipped=1 AND name='".$NAME."' AND uid={$UID}"); //sprawdzenie czy przedmiot tego typu nie jest już założony
                
                
                
                if(!$select) { //można założyć
                 
                    
                         
                  $res = DatabaseManager::updateTable("items", Array('is_equipped' => '1'), Array('id' => ''.$ITEM_ID.'')); //założenie przedmiotu
                        
   
                    if($res) {
                        return true;                                                  
                    }
                        
                    else {
                        return false;
                    }
                  
                }
                
                else {
                    return false;
                    exit;
                }                                                                       
    }
    
    public function takeOffItem($UID, $ITEM_ID, $NAME) {
        
     
                $select = DatabaseManager::selectBySQL("SELECT * FROM items WHERE is_equipped=1 AND name='".$NAME."' AND uid={$UID}"); //sprawdzenie czy przedmiot jest założony
                
                
                
                if($select) { //można zdjąć
                 
                    
                         
                  $res = DatabaseManager::updateTable("items", Array('is_equipped' => '0'), Array('id' => ''.$ITEM_ID.''));
                        
   
                    if($res) {
                        return true;                                                  
                    }
                        
                    else {
                        return false;
                    }
                  
                }
                
                else {
                    return false;
                    exit;
                }                                                                       
    }
    
    
     
}

?>